*" PACKAGE AADMIN !"  ᥤ롼
*"                  ver 1.00                   92/06/11 numaguti
*"                  ver 1.00            93/10/08 
*"                  SRC:=$GC/model/agcm5/src/admin/aadmn.F
*"                  DOC:=$GC/model/agcm5/doc/main.tex
***********************************************************************
      PROGRAM GCM5                           !" ᥤ롼
*
*"    ¿ǥ
*"    Arakawa & Suarez ľʬ Һɸ
*"    semi implicit scheme
*"    ɸʪ, ά
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [VAR]
      REAL       GAU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GAPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GAQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GAVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GADIV ( IDIM, JDIM, KMAX )  !" ȯ  
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      REAL       GBU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GBPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GBQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GBVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GBDIV ( IDIM, JDIM, KMAX )  !" ȯ  
      REAL       GBTG  ( IDIM, JDIM )        !" ̲٣ԣ
*"       : ʻǡ(t-t) <DYNMCS>  ʻǡ(t)
*
      REAL       GTUA  ( IDIM, JDIM, KMAX )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, KMAX )  !" ̱ưѲ֣
      REAL       GTH   ( IDIM, JDIM, KMAX )  !" ٻѲ  
      REAL       GTR   ( IDIM, JDIM, KMAX )  !" 漾Ѳ  
      REAL       MSORC ( IDIM, JDIM, KMAX )  !" Ѳ
*"                                          ɲ ishiwatari(93/10/08)
*"       : <PHYSCS> ʻѲ(P) <DYNMCS> ʻѲ(P+D)
*
      INTEGER    ISTEP                 !" ̤ƥå׿
      INTEGER    ITA                   !" ̤(t)
      INTEGER    ITB                   !" ̤(t-t)
      INTEGER    IDATEA( 6 )           !" ǯʬ
      INTEGER    IDATEB( 6 )           !" ǯʬ
      REAL       DELT                  !" ֹߦt
      REAL       DELTP                 !" ʪֹߦt
      LOGICAL    OADVNC                !" 郎ʹԤ뤫ݤ
      LOGICAL    ORSTR                 !" ƽȯϤ뤫ݤ
*"       : 
*
*   [ONCE]
      INTEGER    ITSTRT                !" ׻ϻ
      INTEGER    ITEND                 !" ׻λ
      INTEGER    IORSTR                !" ϴֳ֡ƽȯ
*"       : ¸ѥ᡼
*
      INTEGER    IDELT                 !" ɸֹ
      INTEGER    INISTP                !" ƥå׿
      REAL       TFIL                  !" ֥ե륿
*"       : ֥ƥåץѥ᡼
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       CP                    !" 絤갵Ǯ
*     REAL       EL                    !" ζŷǮ
*     REAL       ER                    !" ϵȾ
*     REAL       GRAV                  !" ϲ®
*     REAL       RAIR                  !" 絤
*     REAL       RVAP                  !" 
*     REAL       CPVAP                 !" 갵Ǯ
*     REAL       DH2O                  !" ̩
*     REAL       EPSV                  !" 絤ʬ
*     REAL       ES0                   !" ˰¾
*     REAL       STB                   !" Stefan-Boltzman
*     REAL       FKARM                 !" Karman 
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       SIG   ( KMAX )        !" ҥ٥()
      REAL       SIGM  (KMAX+1)        !" ҥ٥(Ⱦ)
      REAL       DSIG  ( KMAX )        !" ()
      REAL       DSIGM (KMAX+1)        !" (Ⱦ)
*"       : ɸ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
*
*
*" << SETPUP :  >>
*
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL SETPAR                      !" ¸ѥ᡼
     O         ( ITSTRT, ITEND , IORSTR,
     O           IDELT , INISTP, TFIL    )
*
      CALL SETCOR                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           SIG   , DSIG  ,
     O           SIGM  , DSIGM  )
*
      CALL RDSTRT                      !" ͤɤ߹ߤȺ
     O         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     O           GAVOR , GADIV ,
     O           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     O           GBVOR , GBDIV ,
     O           ITA   , ITB   , IDATEA, IDATEB, ISTEP ,
     C           ITSTRT, ALAT  , DLAT                    )
*
      CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'start GA'      )
      CALL ADMXMN 
     I         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBDIV , GBVOR , ITB   , 'start GB'      )
*
      CALL RDSTRG                      !" ɽͤɤ߹
     O         ( GBTG  ,
     I           GBT   ,
     C           ITB     )
*
      CALL SETTIM                      !" 򵭲 
     I         ( ITA   , ITB   , IDATEA, IDATEB, ISTEP  )
      CALL AHSTRG                      !" ɸʿѽϤϿ
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
 5000 CONTINUE
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'begin LOOP'    )
#endif
         ISTEP = ISTEP + 1
*
*     << START : ƥåפϤν >>
*
         CALL CLCSTR ( 'TIMCON' )
*
         CALL TIMSTP                   !"  
     O         ( DELT  , OADVNC, ORSTR ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  ,
     C           IDELT , INISTP, ITEND , IORSTR          )
*
         CALL SAVEGB                   !" t-tΥǡ򥻡
     I         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV                           )
         CALL CLCEND ( 'TIMCON' )
*
*"    << INTEGR : ʬ >>
* 
        CALL CLCSTR ( 'PHYSCS' )
*
         DELTP = 2 * DELT 
*
         CALL PHYSCS                   !" ʪ
     O         ( GTUA  , GTVA  , GTH   , GTR   , MSORC , 
     M           GBTG  ,
     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV , 
     I           ITB   , IDATEB, DELTP , DELT , 
     C           ALON  , ALAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM          )
*"                           MSORC ɲ (93/10/08)
*
         CALL CLCEND ( 'PHYSCS' )
*
         CALL CLCSTR ( 'DYNMCS' )
*
         CALL DYNMCS                   !" ϳعȻʬ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     M           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GAVOR , GADIV , GBVOR , GBDIV ,
     M           GTUA  , GTVA  , GTH   , GTR   ,
     I           ITA   , DELT  , OADVNC, MSORC ,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           SIG   , SIGM  , DSIG  , DSIGM           )
*"                           MSORC ɲ (93/10/08)
         write (6,*) 'in aadm3: after dynmcs'
*
         CALL CLCEND ( 'DYNMCS' )
*
#ifdef DEBUG
         CALL ADMXMN 
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GADIV , GAVOR , ITA   , 'after DYNMCS'    )
#endif
*
*"    << ADJST : ʬĴ >>
*
         CALL CLCSTR ( 'PADJST' )
*
         write (6,*) 'in aadm3: before padjust'
         CALL PADJST                   !" ʪĴ
     M         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     I           DELT*2.,
     C           SIG   , SIGM  , DSIG   , DSIGM         )
*
         CALL CLCEND ( 'PADJST' )
         CALL CLCSTR ( 'TFILT' )
*
         IF ( OADVNC ) THEN
            CALL TFILT                 !" ե륿
     M         ( GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     M           GBVOR , GBDIV ,
     I           GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     C           TFIL                                   )
         ENDIF
*
         CALL CLCEND ( 'TFILT' )
*
*"    << OUTPUT : ǡ >>
         IF ( OADVNC ) THEN
            CALL CLCSTR ( 'HISTIN' )
            CALL HISTIN ( GBU   , 'U'   ) !" ϥǡε
            CALL HISTIN ( GBV   , 'V'   )
            CALL HISTIN ( GBT   , 'T'   )
            CALL HISTIN ( GBPS  , 'PS'  )
            CALL HISTIN ( GBQ   , 'Q'   )
            CALL HISTIN ( GBVOR , 'VOR' )
            CALL HISTIN ( GBDIV , 'DIV' )
            CALL HISTIN ( GBTG  , 'TG'  )
            CALL CLCEND ( 'HISTIN' )
*
            CALL CLCSTR ( 'HISTOU' )
            CALL HISTRP
            CALL HISTOU                !" ǡ
            CALL CLCEND ( 'HISTOU' )
         ENDIF
*
*"    << NEXT : Υƥåפ >>
*
         CALL CLCSTR ( 'MISC' )
*
         CALL    ADVSTP                !" ѿʤ
     O         ( ITA   , ITB   , IDATEA, IDATEB,
     I           OADVNC                          )
*
         IF ( ORSTR ) THEN
            CALL WRRSTR                !" ꥹȥե񤭹
     I         ( GAU   , GAV   , GAT   , GAPS  , GAQ   ,
     I           GAVOR , GADIV ,
     I           GBU   , GBV   , GBT   , GBPS  , GBQ   ,
     I           GBVOR , GBDIV ,
     I           ITA   , ITB   , IDATEA, IDATEB, ISTEP  )
*
            CALL WRRSTG   !" ɽꥹȡեν񤭹
     I         ( GBTG  ,
     I           ITB   , IDATEB, ISTEP  )
         ENDIF
*
         CALL CLCEND ( 'MISC' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
      IF ( .NOT. ( ITB .GE. ITEND )  ) GOTO  5000
*
      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
***********************************************************************
      SUBROUTINE AHSTRG                !" ɸʿѽϤϿ
*
*   [INTERN PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS', VMISS )   !" »
*
      CALL     HISTRG                  !" ϤϿ
     I       ( 'U     ', 'u-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'V     ', 'v-velocity          ' ,'m/s   ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'T     ', 'temperature         ' ,'K     ', 'ALEV',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'PS    ', 'surface pressure    ' ,'mb    ', 'ASFC',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      CALL     HISTRG
     I       ( 'Q     ', 'specific humidity   ' ,'g/g   ', 'ALEV',
     I           VMISS , VMISS , 1.E-3 , 5.E-3 , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , 'X'     ,'(3PF12.3)' )
*
      CALL     HISTRG
     I       ( 'VOR   ', 'vorticity           ' ,'1/s   ', 'ALEV',
     I           VMISS , VMISS , 1.E-6 , 5.E-6 , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL     HISTRG
     I       ( 'DIV   ', 'divergence          ' ,'1/s   ', 'ALEV',
     I           VMISS , VMISS , 1.E-6 , 5.E-6 , ISTYPL  ,
     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      CALL     HISTRG
     I       ( 'TG    ', 'ground temperature  ' ,'K     ', 'ASFC',
     I           VMISS , VMISS , 2.5   , 10.   , ISTYPL  ,
     I         'CON'   , '   ' , 0     , 0     , 'X'     ,'(F12.3)' )
*
      RETURN
      END
*************************************************************************
      SUBROUTINE ADMXMN        !" debug monitor
     I         ( GDU   , GDV   , GDT   , GDPS  , GDQ   ,
     I           GDDIV , GDVOR , IT    , HLABEL          )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#endif
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDT   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDPS  ( IDIM, JDIM       )  !" ɽ
      REAL       GDQ   ( IDIM, JDIM, KMAX )  !" 漾  
      REAL       GDVOR ( IDIM, JDIM, KMAX )  !"   
      REAL       GDDIV ( IDIM, JDIM, KMAX )  !" ȯ  
      INTEGER    IT
      CHARACTER  HLABEL *(*)
*
      WRITE ( 6,* ) HLABEL, ' IT= ', IT
      CALL MAXMIN( GDU,   IDIM, JDIM, KMAX, IDIM, JDIM, 'U'   )
      CALL MAXMIN( GDV,   IDIM, JDIM, KMAX, IDIM, JDIM, 'V'   )
      CALL MAXMIN( GDT,   IDIM, JDIM, KMAX, IDIM, JDIM, 'T'   )
      CALL MAXMIN( GDPS,  IDIM, JDIM, 1,    IDIM, JDIM, 'PS'  )
      CALL MAXMIN( GDQ,   IDIM, JDIM, KMAX, IDIM, JDIM, 'Q'   )
      CALL MAXMIN( GDVOR, IDIM, JDIM, KMAX, IDIM, JDIM, 'VOR' )
      CALL MAXMIN( GDDIV, IDIM, JDIM, KMAX, IDIM, JDIM, 'DIV' )
*
      RETURN
      END
