* PACKAGE P2ELGR  !" $BJ*M}2aDx(B(2) $B:G>eAX!&:G2<AX$G=ENOGH%+%C%H(B
*
*"$BMzNr(B 95/01/30 $B@PEO@5<y(B            
*"
***********************************************************************
      SUBROUTINE ELGRWV      !" $B2<AX!&>eAX$G$NGH$N8:?j(B
     O         ( EGTG , 
     I           GDT  ) 
*
*"  $B>eAX$N8:?j!'(B 
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [INPUT] 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" $B29EY(B  $B#T(B
*
*   [OUTPUT]
      REAL       EGTG   ( IDIM, JDIM, KMAX )   !" $B>eAX8:?j#TJQ2=(B
*
*   [INTERNAL PARM]
      REAL    S1
      REAL    SKMAX
      REAL    TAUEG                  !" $B29EY4KOB;~4V(B
      DATA    TAUEG / 10800.0 /
*
      NAMELIST  /NMELGW/ TAUEG
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IFPAR, JFPAR
      REAL       MGDT  ( KMAX )        !" $B#TA45eJ?6Q(B
*
*   [INTERNAL PARM] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' ELLIMINATION SHORT WAVES - DATE=95/01/30'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMELGW, END=190 )
  190    WRITE  ( JFPAR, NMELGW )
*
         S1    = 0.5051
         SKMAX = 0.3367
      ENDIF
*
      CALL RESET ( EGTG, IDIM*JDIM*KMAX )
*
      CALL RESET ( MGDT, KMAX )
*
      DO 1200 K=1, KMAX
         DO 1100 J=1,JDIM
            DO 1100 I=1,IDIM
               MGDT(K) = MGDT(K) + GDT(I,J,K)
 1100    CONTINUE 
         MGDT(K) = MGDT(K)/(Real(IDIM)*Real(JDIM))
 1200 CONTINUE 
*
c$$$      write (6,*) 'in p2udmp: after 1200'
      DO 2100 I = 1, IDIM
         DO 2100 J = 1, JDIM
            EGTG(I,J,1) = - 1.0/TAUEG * 
     &                     ( (GDT(I,J,1) - MGDT(1) )
     &                       - S1 * (GDT(I,J,2) -MGDT(2) ) )
            EGTG(I,J,KMAX) = - 1.0/TAUEG * 
     &                     ( (GDT(I,J,KMAX) - MGDT(KMAX) )
     &                       - SKMAX * (GDT(I,J,KMAX-1) -MGDT(KMAX-1)))
 2100 CONTINUE 
*
c$$$      write (6,*) 'in p2udmp: after 2100'
*
      RETURN
      END

