* PACKAGE P2MLSC  !" ʪ(2) 絬϶ŷ
*
**********************************************************************
      SUBROUTINE LSCOND      !" 絬϶ŷ
     M         ( GDT   , GDQ   ,
     M           GQPR  , GQLSC , GSLSC ,
     I           GDP   , GDPM  , DELTA  )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDQ   ( IDIM*JDIM, KMAX )   !" 漾  
      REAL       GQPR  ( IDIM*JDIM       )   !" ߿
      REAL       GQLSC ( IDIM*JDIM, KMAX )   !" ŷǮΨ
      REAL       GSLSC ( IDIM*JDIM, KMAX )   !" ŷ漾Ѳ
*
*   [INPUT] 
      REAL       GDP    ( IDIM*JDIM, KMAX )  !"   
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 )!" Ⱦ
      REAL       DELTA                       !" 2t
*
*   [INTERNAL PARM] 
      REAL       RCRITL                      !" ׳м
      DATA       RCRITL / 1.0   /
      NAMELIST  /NMMLSC/ RCRITL
      SAVE       RCRITL
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           GDQB
      REAL       GDQB  ( IDIM*JDIM, KMAX )   !" Ĵ漾
*
      INTEGER    IJ, K
      INTEGER    IFPAR, JFPAR
      REAL       ELF
      REAL       QSAT, DQSAT, QEXE, DT, DQ
*      
#ifdef SYS_IBMS
      INCLUDE   (ZQSAT)                      !" ˰¿
#else
#include        "zqsat.F"                    !" ˰¿
#endif
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' LARGE SCALE CONDENSATION P2.1 DATE=90/09/12'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMMLSC, END=190 )
  190    WRITE  ( JFPAR, NMMLSC )
      ENDIF
*
      ELF = EL / CP
*
      DO 200 K = 1, KMAX
         DO 200 IJ = 1, IDIM*JDIM
            GDQB ( IJ,K ) = GDQ ( IJ,K )
  200 CONTINUE
*
*"         < 1. Ĵ >
*
      DO 1000 K = KMAX, 1, -1
         DO 1000 IJ = 1, IDIM*JDIM
*
            QSAT   = FQSAT ( GDT( IJ,K ), GDP( IJ,K ) )
*
            IF ( GDQ ( IJ,K )/QSAT .GE. RCRITL ) THEN
*"                                                [ ˰ ]
*
               DQSAT  = FDQSAT( GDT( IJ,K   ), QSAT  )
*
               QEXE   = GDQ ( IJ,K ) - QSAT
               DT     = ELF * QEXE / ( 1. + ELF * DQSAT )
               DQ     = DQSAT * DT
*
               if(ij .eq. 946) then
                 write(6,*) ' P2MLSC(itr=1):k,gdt,gdq,dt,dq'
                 write(6,*) k,gdt(ij,k),gdq(ij,k),dt,dq
               endif
*
               GDT   ( IJ,K ) = GDT( IJ,K ) + DT
               GDQ   ( IJ,K ) = QSAT + DQ
*
               GQLSC ( IJ,K ) = GQLSC( IJ,K ) + DT / DELTA
               GQPR  ( IJ )   = GQPR( IJ )
     &                        + DT * CP / DELTA
     &                          * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/GRAV
*"             ------------- iteration (1) ----------------------------
*
               QSAT   = FQSAT ( GDT( IJ,K ), GDP( IJ,K ) )
               DQSAT  = FDQSAT( GDT( IJ,K ), QSAT  )
*
               QEXE   = GDQ ( IJ,K ) - QSAT
               DT     = ELF * QEXE / ( 1. + ELF * DQSAT )
               DQ     = DQSAT * DT
*
               if(ij .eq. 946) then
                 write(6,*) ' P2MLSC(itr=2):k,gdt,gdq,dt,dq'
                 write(6,*) k,gdt(ij,k),gdq(ij,k),dt,dq
               endif
*
               GDT   ( IJ,K ) = GDT( IJ,K ) + DT
               GDQ   ( IJ,K ) = QSAT + DQ
*
               GQLSC ( IJ,K ) = GQLSC( IJ,K ) + DT / DELTA
               GQPR  ( IJ )   = GQPR( IJ )
     &                        + DT * CP / DELTA
     &                          * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/GRAV
*
*"             ------------- iteration (2) ----------------------------
*
               QSAT   = FQSAT ( GDT( IJ,K ), GDP( IJ,K ) )
               DQSAT  = FDQSAT( GDT( IJ,K ), QSAT  )
*
               QEXE   = GDQ ( IJ,K ) - QSAT
               DT     = ELF * QEXE / ( 1. + ELF * DQSAT )
               DQ     = DQSAT * DT
*
               if(ij .eq. 946) then
                 write(6,*) ' P2MLSC(itr=3):k,gdt,gdq,dt,dq'
                 write(6,*) k,gdt(ij,k),gdq(ij,k),dt,dq
               endif
*
               GDT   ( IJ,K ) = GDT( IJ,K ) + DT
               GDQ   ( IJ,K ) = QSAT + DQ
*
               GQLSC ( IJ,K ) = GQLSC( IJ,K ) + DT / DELTA
               GQPR  ( IJ )   = GQPR( IJ )
     &                        + DT * CP / DELTA
     &                          * ( GDPM( IJ,K )-GDPM( IJ,K+1 ) )/GRAV
*
               GSLSC ( IJ,K ) = GSLSC( IJ,K )
     &                        + ( GDQ( IJ,K ) - GDQB( IJ,K ) )/DELTA
*
            ENDIF
 1000 CONTINUE
*
      RETURN
      END
