*"   PACKAGE  
* PACKAGE P2RDLN  !" ʪ(2) Ĺ(¿) 
*
*"  93/08/29 ݺ            Ĺѹ
*"  94/07/16             ͷ׻
*"  94/09/09             ˤ륹ѹ
*"                                   絤Τ
***********************************************************************
      SUBROUTINE LNGFLX           !" Ĺͥեå
     O         ( RFLUX , DRFLUX,
     I           GDTM  , GDTG  , TAUQ  , TAUA  ,
     W           TRNSM1, TRNSM2, TRANS , PIB   , PIBGND  )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                       !" ʻȿ
      INCLUDE   (ZCCOM)                       !" ɸʪ
#else
#include        "zcdim.F"                     !" ʻȿ
#include        "zccom.F"                     !" ɸʪ
#endif
*
*   [OUTPUT] 
      REAL       RFLUX  ( IDIM*JDIM, KMAX+1 )     !" Ĺȥեå
      REAL       DRFLUX ( IDIM*JDIM, KMAX+1, 0:1 )!" ĹɽѲ
*
*   [INPUT] 
      REAL       GDTM   ( IDIM*JDIM, KMAX+1 ) !" (Ⱦ)
*                                    !"   ݺǤѹ(94/09/09)
      REAL       GDTG   ( IDIM*JDIM )         !" ɽ̲
      REAL       TAUQ   ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       TAUA   ( IDIM*JDIM, KMAX+1 ) !" Ū絤
*
*   [WORK] 
      REAL       TRNSM1 ( IDIM*JDIM, KMAX+1 ) !" 1/2 ٥뤫Ʃ᷸
      REAL       TRNSM2 ( IDIM*JDIM, KMAX+1 ) !" 3/2 ٥뤫Ʃ᷸
*                                                !" ݺ 93/08/29 ɲ
      REAL       TRANS  ( IDIM*JDIM, KMAX+1 ) !" Ʃ᷸
      REAL       ODEPTH ( IDIM*JDIM, KMAX+1 ) !" Ū
      REAL       PIBM    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIB    ( IDIM*JDIM, KMAX+1 ) !" У¡ң**4
      REAL       PIBGND ( IDIM*JDIM )         !" ɽΦУ
*
*   [INTERNAL PARM] 
      INTEGER    NCLNGD
      PARAMETER (NCLNGD = 10)
      INTEGER    NCLNG                        !" ĹȥХɿ
      REAL       ABSQL  ( NCLNGD )            !" εۼ
      REAL       ABSAL  ( NCLNGD )            !" εۼ
      REAL       RWGTL  ( NCLNGD )            !" Хɥ
      REAL       PATHC                        !" ϩĹΥե
      REAL       CRDTAU                           !" ѹ
      DATA       NCLNG  / 4 /
      DATA       ABSQL  / 8.0  , 1.0  , 0.1  , 0.0  , 6*0.   /
      DATA       ABSAL  / 0.0  , 0.0  , 0.0  , 5.E-5, 6*0.   /
      DATA       RWGTL  / 0.2  , 0.1  , 0.1  , 0.6  , 6*0.   /
      DATA       PATHC  / 1.5   /
      DATA       CRDTAU / 0.1   /
*
      NAMELIST  /NMRADL/ NCLNG , ABSQL , ABSAL , RWGTL , PATHC , 
     &                   CRDTAU
      SAVE
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*
*   [INTERNAL WORK] 
      INTEGER    IJ, K, KK, IC
      INTEGER    IFPAR, JFPAR
      REAL       RUFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       RDFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       UFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       DFLUX  ( IDIM*JDIM, KMAX+1 )     !" եå
      REAL       SUMWGL
      SAVE       RUFLUX,RDFLUX
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' LONGWAVE RADIATION(GREY) DATE=94/11/08'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMRADL, END=190 )
  190    WRITE  ( JFPAR, NMRADL )
*
         SUMWGL = 0.  
         DO 210 IC = 1, NCLNG
            SUMWGL = SUMWGL + RWGTL( IC )
  210    CONTINUE
         DO 220 IC = 1, NCLNG
            RWGTL( IC ) =  RWGTL( IC ) / SUMWGL
  220    CONTINUE
*
      ENDIF
*
*"         < 1. У, Ӥη׻ >
*
      DO 1100 K = 1, KMAX+1
         DO 1110 IJ = 1, IDIM*JDIM
            PIBM  ( IJ,K ) = STB * ( GDTM( IJ,K )**4 )
 1110    CONTINUE
 1100 CONTINUE
*
      DO 1200 IJ = 1, IDIM*JDIM
         PIBGND( IJ ) = STB * ( GDTG( IJ )**4 )
 1200 CONTINUE
*
      CALL RESET ( ODEPTH, IDIM*JDIM*(KMAX+1) )
*
*"        ʲǤ¿бǤƤʤ.
*"        줾1 ޤ.
*"
      DO 1300 IC = 1, NCLNG
         DO 1310 IJ = 1, IDIM*JDIM
            DO 1320 K = 1, KMAX+1
                   ODEPTH( IJ,K )
     &         =   PATHC * (   ABSQL(IC) * TAUQ( IJ,K )
     &                       + ABSAL(IC) * TAUA( IJ,K ) )
 1320       CONTINUE
 1310    CONTINUE
 1300 CONTINUE
*
c$$$      write (6,*) 'in p2radlN:ij,k,odepth'
c$$$      do 33 ij=1,idim*jdim
c$$$         do 33 k=1,kmax+1
c$$$            write (6,*) ij,k,odepth(ij,k)
c$$$ 33   continue 
*
      CALL RESET ( RUFLUX, IDIM*JDIM*(KMAX+1) )
      CALL RESET ( RDFLUX, IDIM*JDIM*(KMAX+1) )
*
*"         < 2. Ʃؿ׻ >
*
*
      DO 2000 K = 1, KMAX+1
*
         CALL RESET ( TRANS, IDIM*JDIM*(KMAX+1) )
*
         DO 2100 IC = 1, NCLNG
            DO 2110 KK = 1, KMAX+1
               DO 2120 IJ = 1, IDIM*JDIM
                  TRANS( IJ,KK )
     &            = TRANS( IJ,KK )
     &              +  RWGTL ( IC )
     &                  * EXP( - PATHC
     &                         * (  ABSQL(IC)*ABS(  TAUQ( IJ,KK )
     &                                            - TAUQ( IJ,K  )  )
     &                            + ABSAL(IC)*ABS(  TAUA( IJ,KK )
     &                                            - TAUA( IJ,K  )  )  )
     &                       )
 2120          CONTINUE
 2110       CONTINUE
 2100    CONTINUE
*
*"      < 3.   ͥեå׻  >       !"  ݺ 93/08/29 ѹ
*
         DO 3100 IJ = 1, IDIM*JDIM
            RUFLUX ( IJ,K ) = PIBM ( IJ,K ) 
     &                        + ( PIBGND(IJ) - PIBM(IJ,1) )
     &                          * TRANS ( IJ,1)
            RDFLUX ( IJ,K ) = - PIBM ( IJ,KMAX+1 )
     &                          * TRANS ( IJ, KMAX+1 )
     &                        + PIBM ( IJ,K )
 3100    CONTINUE

         DO 3200 KK = 2,K
            DO 3200 IJ = 1, IDIM*JDIM
               IF( ABS(ODEPTH( IJ,KK ) - ODEPTH( IJ,KK-1 ) )
     &                .GT. CRDTAU ) THEN
                   RUFLUX( IJ,K ) 
     &             = RUFLUX ( IJ, K ) 
     &               - (PIBM( IJ,KK-1 ) - PIBM ( IJ, KK ))
     &                 / (ODEPTH( IJ,KK-1 ) - ODEPTH( IJ,KK ) )
     &                 * ( TRANS ( IJ , KK-1 ) - TRANS ( IJ, KK ) ) 
c$$$                   if(ij .eq. 1) then
c$$$                     write (6,*) 'in p2radlN:u:k,kk,pibm,odepth,trans'
c$$$                     write (6,*) k,kk,pibm(1,kk-1),pibm(1,kk)
c$$$                     write (6,*) odepth( IJ,KK-1 ),odepth( IJ,KK )
c$$$                     write (6,*) trans( IJ,KK-1 ),trans( IJ,KK )
c$$$                     write (6,*) ruflux(ij,k)
c$$$                   end if
                ELSE
                   RUFLUX( IJ,K ) 
     &             = RUFLUX ( IJ, K ) 
     &               + (PIBM( IJ,KK-1 ) - PIBM ( IJ, KK ) )
     &                 * ( TRANS ( IJ, KK ) + TRANS ( IJ , KK-1 ) )/2.0
c$$$                   if(ij .eq. 1) then
c$$$                     write (6,*) 'in p2radlN:u:k,kk,pibm,odepth,trans'
c$$$                     write (6,*) k,kk,pibm(1,kk-1),pibm(1,kk)
c$$$                     write (6,*) trans( IJ,KK-1 ),trans( IJ,KK )
c$$$                     write (6,*) ruflux(ij,k)
c$$$                   end if
                END IF
 3200   CONTINUE
c$$$           write (6,*) 'UUUUU',k,ruflux(1,k),'UUUUU'
*
         DO 3300 KK = K+1, KMAX+1
            DO 3300 IJ = 1, IDIM*JDIM
               IF( ABS(ODEPTH( IJ,KK ) - ODEPTH( IJ,KK-1 ) ) 
     &                .GT. CRDTAU ) THEN
                  RDFLUX( IJ,K ) 
     &             = RDFLUX ( IJ, K ) 
     &               - ( PIBM( IJ,KK-1 ) - PIBM ( IJ, KK ) )
     &                 / ( ODEPTH( IJ,KK-1 ) - ODEPTH( IJ,KK ) )
     &                 * ( TRANS ( IJ , KK-1 ) - TRANS ( IJ, KK ) ) 
c$$$                   if(ij .eq. 1) then
c$$$                     write (6,*) 'in p2radlN:d::pibm,odepth,trans'
c$$$                     write (6,*) k,kk,pibm(1,kk-1),pibm(1,kk)
c$$$                     write (6,*) odepth( IJ,KK-1 ),odepth( IJ,KK )
c$$$                     write (6,*) trans( IJ,KK-1 ),trans( IJ,KK )
c$$$                   end if
               ELSE
                  RDFLUX( IJ,K ) 
     &            = RDFLUX ( IJ, K ) 
     &               - ( PIBM( IJ,KK-1 ) - PIBM ( IJ, KK ) )
     &                 * ( TRANS ( IJ, KK ) + TRANS ( IJ , KK-1 ) )/2.0
               END IF
 3300   CONTINUE
*
        DO 3400 IJ = 1, IDIM*JDIM
                RFLUX( IJ,K ) 
     &             = RUFLUX( IJ, K ) - RDFLUX ( IJ, K ) 
 3400   CONTINUE
*
*"       < 4.  ׻Ʃؿ >       !"  ݺ 93/08/29 ѹ
*
        DO 4000 IJ= 1 ,IDIM*JDIM
            TRNSM1 ( IJ,K ) = TRANS( IJ,1 )
            TRNSM2 ( IJ,K ) = TRANS( IJ,2 )
 4000   CONTINUE
*
 2000 CONTINUE
*
*"         < 5. ɽ >               !"  ݺ 93/08/29 ѹ
*                           !"   94/09/09 Ȥ᤹
      DO 5100 K = 1, KMAX+1
         DO 5110 IJ = 1, IDIM*JDIM
            DRFLUX( IJ,K,0 ) = 4. * PIBGND( IJ   ) / GDTG  ( IJ )
     &                            * TRNSM1( IJ,K )
*                            !" : եåʬ
            DRFLUX( IJ,K,1 ) = -4. * PIBM  ( IJ,1 ) / GDTM  ( IJ,1 )
     &                            * TRNSM1( IJ,K )
*                            !" : եåʬ
*                            !" : եåʬ
            IF( ABS(ODEPTH( IJ,2 ) - ODEPTH( IJ,1 ) ) 
     &                .GT. CRDTAU ) THEN
               DRFLUX( IJ,K,1 ) = DRFLUX( IJ,K,1 )
     &                         + PIBM ( IJ,1 ) / GDTM (IJ,1 )
     &                       / ( ODEPTH( IJ,1 ) - ODEPTH( IJ,2 ) )
     &                 * ( TRNSM1 ( IJ , K ) - TRNSM2 ( IJ, K ) ) 
            ELSE 
               DRFLUX( IJ,K,1 ) = DRFLUX( IJ,K,1 )
     &                         + PIBM ( IJ,1 ) / GDTM (IJ,1 )
     &                            * (TRNSM1( IJ,K )+TRNSM2( IJ,K ))/2.
            END IF
 5110    CONTINUE
 5100 CONTINUE
*
      RETURN
***************************************************************
      ENTRY UDFLUX
     O      (UFLUX,DFLUX)
*
*"                             94/08/05 ɲ 
*
      CALL COPY (UFLUX,RUFLUX,IDIM*JDIM*(KMAX+1))
      CALL COPY (DFLUX,RDFLUX,IDIM*JDIM*(KMAX+1))
*
      END
