* PACKAGE P2ZFLT  !" $BJ*M}2aDx(B(2) $B1tD>J}8~$K%U%#%k%?$r$+$1$k(B
*
*"$BMzNr(B 95/04/05 $B@PEO@5<y(B            
*"$BMzNr(B 95/05/02 $B@PEO@5<y(B            
*"
***********************************************************************
      SUBROUTINE VERFLT      !" $B1tD>J}8~$N%U%#%k%?(B
     M         ( GDU  , GDV  , GDT  ,
     O           GTUZF, GTVZF, GTTZF,
     I           DELTA, GDPM  ) 
*
*"  $B1tD>J}8~$N%U%#%k%?(B: Shapiro (1971)
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" $B29EY(B   $B#T(B
      REAL       GDU   ( IDIM, JDIM, KMAX )  !" $BEl@>Iw(B $B#U(B
      REAL       GDV   ( IDIM, JDIM, KMAX )  !" $BFnKLIw(B $B#V(B
*
*   [INPUT]
      REAL       GDPM  ( IDIM, JDIM, KMAX+1 )  !"  ($B%@%_!<(B)
*
*   [INPUT]
      REAL    DELTA
*
*   [INTERNAL PARM]
      REAL    SH                               !" $B%U%#%k%?78?t(B
      REAL    SM                               !" $B%U%#%k%?78?t(B
      DATA    SH / 0.5 /
      DATA    SM / 0.5 /
*
      NAMELIST  /NMZFLT/ SH,SM
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IFPAR, JFPAR
*
*   [OUTPUT] 
      REAL       GTTZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#TJQ2=N((B
      REAL       GTUZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#UJQ2=N((B
      REAL       GTVZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#VJQ2=N((B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' Z FILTER PACKAGE - DATE=95/05/02'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMZFLT, END=190 )
  190    WRITE  ( JFPAR, NMZFLT )
      ENDIF
*
      CALL RESET ( GTTZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTUZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTVZF, IDIM*JDIM*KMAX )
*
      DO 1200 J=1,JDIM
         DO 1200 I=1,IDIM
            GTTZF(I,J,1) = SH/2.0*(GDT(I,J,2)-GDT(I,J,1))/DELTA
            GTUZF(I,J,1) = SM/2.0*(GDU(I,J,2)-GDU(I,J,1))/DELTA
            GTVZF(I,J,1) = SM/2.0*(GDV(I,J,2)-GDV(I,J,1))/DELTA
            DO 1100 K=2, KMAX-1
                  GTTZF(I,J,K)
     &          = SH/2.0*(GDT(I,J,K-1)-2.0*GDT(I,J,K)+GDT(I,J,K+1))
     &            /DELTA
                  GTUZF(I,J,K)
     &          = SM/2.0*(GDU(I,J,K-1)-2.0*GDU(I,J,K)+GDU(I,J,K+1))
     &            /DELTA
                  GTVZF(I,J,K)
     &          = SM/2.0*(GDV(I,J,K-1)-2.0*GDV(I,J,K)+GDV(I,J,K+1))
     &            /DELTA
 1100       CONTINUE 
            GTTZF(I,J,KMAX) 
     &         = SH/2.0*(GDT(I,J,KMAX-1)-GDT(I,J,KMAX))/DELTA
            GTUZF(I,J,KMAX)
     &         = SM/2.0*(GDU(I,J,KMAX-1)-GDU(I,J,KMAX))/DELTA
            GTVZF(I,J,KMAX)
     &         = SM/2.0*(GDV(I,J,KMAX-1)-GDV(I,J,KMAX))/DELTA

 1200 CONTINUE 
*
      DO 2100 I = 1, IDIM
         DO 2100 J = 1, JDIM
            DO 2100 K=1,KMAX
               GDT(I,J,K) = GDT(I,J,K) + GTTZF(I,J,K)*DELTA
               GDU(I,J,K) = GDU(I,J,K) + GTUZF(I,J,K)*DELTA
               GDV(I,J,K) = GDV(I,J,K) + GTVZF(I,J,K)*DELTA
 2100 CONTINUE 
*
      RETURN
      END


