* PACKAGE P2ZFLT  !" $BJ*M}2aDx(B(2) $B1tD>J}8~$K%U%#%k%?$r$+$1$k(B $B%@%_!<(B
*
*"$BMzNr(B 95/04/05 $B@PEO@5<y(B            
*"
***********************************************************************
      SUBROUTINE VERFLT      !" $B1tD>J}8~$N%U%#%k%?(B $B%@%_!<(B
     M         ( GDU  , GDV  , GDT  ,
     O           GTUZF, GTVZF, GTTZF,
     I           DELTA, GDPM  ) 
*
*"  $B1tD>J}8~$N%U%#%k%?(B: Shapiro (1971)
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" $B29EY(B   $B#T(B
      REAL       GDU   ( IDIM, JDIM, KMAX )  !" $BEl@>Iw(B $B#U(B
      REAL       GDV   ( IDIM, JDIM, KMAX )  !" $BFnKLIw(B $B#V(B
*
*   [INPUT]
      REAL       GDPM  ( IDIM, JDIM, KMAX+1 )  !" 
*
*   [INPUT]
      REAL    DELTA
*
*   [OUTPUT] 
      REAL       GTTZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#TJQ2=N((B
      REAL       GTUZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#UJQ2=N((B
      REAL       GTVZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#VJQ2=N((B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' Z FILTER DUMMY - DATE=95/04/05'
         OFIRST = .FALSE.
      ENDIF
*
      CALL RESET ( GTTZF, IDIM*JDIM*KMAX )
*
      RETURN
      END


